1.1 Live Coding

# Live Coding

Jedna z nejzajímavějších věcí na Sonic Pi je možnost psát a *upravovat kód v reálném čase* k tvorbě hudby, podobně jako bys to dělal třeba s kytarou. To znamená, že s trochou cviku můžeš vzít Sonic Pi na pódium a vystpovat s ním před publikem.

## Uvolni svou mysl

Ještě než se v tomto návodu pustíme do detailního popisu jak Sonic Pi funguje, rád bych ti ukázal jaké to je kódovat živě. Vůbec se neboj, pokud něčemu (nebo ničemu) zatím nerozumíš. Zatím se v klidu posaď, uvolni a užívej...

## Živá smyčka

Pojďme začít, zkopíruj následující kód do prázdného bufferu:

```
live_loop :flibble do
  sample :bd_haus, rate: 1
  sleep 0.5
end
```

A teď klikni na tlačítko`Spustit` a uslyšíš bušit příjemný rychlý basový buben. Kdykoliv budeš chtít zvuk zastavit, stačí stisknout tlačítko `Stop`. Ale ještě ho nemačkej... Nejdřív postupuj podle těchto kroků:

1. Ujisti se, že basový buben pořád jede
2. Uprav hodnotu`sleep` z`0.5` na něco většího, třeba `1`.
3. Znovu zmáčkni tlačítko `Spustit`
4. Všimni si, jak se změnila rychlost bubnu.
5. A nakonec, *zapamatuj si tento moment*, je to poprvé, co jsi živě kódoval se Sonic Pi. A pravděpodobně to nebude naposled…

Ok, to bylo celkem snadné. Pojďme zkusit přidat něco dalšího. Nad `sample :bd_haus` přidej řádek `sample :ambi_choir, rate: 0.3`. Tvůj kód by měl vypadat nějak takhle:

```
live_loop :flibble do
  sample :ambi_choir, rate: 0.3
  sample :bd_haus, rate: 1
  sleep 1
end
```

Now, play around. Change the rates - what happens when you use high values, or small values or negative values? See what happens when you change the `rate:` value for the `:ambi_choir` sample just slightly (say to `0.29`). What happens if you choose a really small `sleep` value? See if you can make it go so fast your computer will stop with an error because it can't keep up (if that happens, just choose a bigger `sleep` time and hit `Run` again).

Try commenting one of the `sample` lines out by adding a `#` to the beginning:

```
live_loop :flibble do
  sample :ambi_choir, rate: 0.3
#  sample :bd_haus, rate: 1
  sleep 1
end
```

Notice how it tells the computer to ignore it, so we don't hear it. This is called a comment. In Sonic Pi we can use comments to remove and add things into the mix.

Finally, let me leave you something fun to play with. Take the code below, and copy it into a spare buffer. Now, don't try to understand it too much other than see that there are two loops - so two things going round at the same time. Now, do what you do best - experiment and play around. Here are some suggestions:

* Try changing the blue `rate:` values to hear the sample sound change.
* Try changing the `sleep` times and hear that both loops can spin round at different rates.
* Try uncommenting the sample line (remove the `#`) and enjoy the sound of the guitar played backwards.
* Try changing any of the blue `mix:` values to numbers between `0` (not in the mix) and `1` (fully in the mix).

Remember to press `Run` and you'll hear the change next time the loop goes round. If you end up in a pickle, don't worry - hit `Stop`, delete the code in the buffer and paste a fresh copy in and you're ready to jam again. Making mistakes is how you'll learn the quickest...


```
live_loop :guit do
  with_fx :echo, mix: 0.3, phase: 0.25 do
    sample :guit_em9, rate: 0.5
  end
#  sample :guit_em9, rate: -0.5
  sleep 8
end
live_loop :boom do
  with_fx :reverb, room: 1 do
    sample :bd_boom, amp: 10, rate: 1
  end
  sleep 8
end
```

Now, keep playing and experimenting until your curiosity about how this all actually works kicks in and you start wondering what else you can do with this. You're now ready to read the rest of the tutorial.

So what are you waiting for...
