10.1 Usando atajos

# Usando atajos

Sonic Pi es tanto un instrumento como un ambiente de código. Los atajos te hacen tocar Sonic Pi de una manera mucho más *eficiente y natural*. Especialmente si tocas en frente de una audiencia en vivo.

Mucho de Sonic Pi puede ser controlado a través del teclado. Mientras te familiarizas trabajando con Sonic Pi, probablemente usarás más y más atajos. *personalmente soy del tipo toca-teclea* (lo que recomiendo aprender) y me frustra el tener que ir al ratón, ya que me ralentiza. Por ello es que utilizo estos atajos regularmente.

Por tanto, si te aprendes los atajos, utilizarás tu teclado de manera eficiente y codificarás como un profesional en poco tiempo.

Sin embargo *no intentes aprender todo al mismo tiempo*, sólo intenta recordar los que más utilizas y continua añadiendo otros a tú práctica.

## Consistencia a través de las plataformas

Imagina que estás aprendiendo el clarinete. Esperarás que todos los clarinetes de cada constructor tenga controles y digitalizaciones similares. Si no fuese así, sería complicado cambiar de clarinetes y tendrías que usar sólo uno.

Unfortunately there are a number of standards for shortcuts with macOS and Windows being two of the major styles and other more esoteric editors such as Emacs offering other approaches. You can currently choose between one of these three styles using the menu `IO -> Shortcut Mode`. You can therefore switch between a Windows and a macOS machine and keep your shortcuts consistent.

## Control y Meta

A key part of the notion of consistency is the naming of shortcuts. In Sonic Pi we use the names *Control* and *Meta* to refer to the two main combination keys. On all platforms *Control* is the same. However, on Linux and Windows, *Meta* is actually the *Alt* key while on Mac *Meta* is the *Command* key. For consistency we'll use the term *Meta* - just remember to map that to the appropriate key on your operating system.

## Abreviaciones

Para mantener las cosas simples y legibles, utilizaremos la abreviación *C-* para *Control* más otra tecla y *M-* por *Meta* más otra tecla. Por ejemplo, si un atajo te requiere que mantengas apretadas ambas *Meta* y *r*, escribiremos elso, así `M-r`. El *-* significa que es al mismo tiempo.

Los siguientes son los atajos que encuentro más útiles.

## Para y comenzar

En vez de comenzar tu código conel ratón, puedes simplemente presionar `M-r`. Similarmente puedes pararlo con `M-s`.

## Navegación

Sin los atajos de navegación estaría perdido. Así que recomiendo que los aprendas. Estos atajos funcional fenomenalmente cuando hayas aprendido a tocar y teclear, ya que usan letras estándar, en vez de requerir que vayas al ratón o las flechas del teclado.

For example, if you're in Emacs Live short cut mode, You can move to the beginning of the line with `C-a`, the end of the line with `C-e`, up a line with `C-p`, down a line with `C-n`, forward a character with `C-f`, and back a character with `C-b`. You can even delete all the characters from the cursor to the end of the line with `C-k`. Other modes will have their own shortcuts which can be easily discovered in the app menu.

## Código legibles

Para auto-alinear el código, simplemete presiona `M-m`.

## Sistema de ayuda

Para aparecer el sistema de ayuda, presiona `M-i`. Sin embargo, un atajo mucho más útil es `C-i` que buscará la palabra debajo del cursor y mostrará los documentos si encuentra algo. ¡Ayuda instantánea!

Para una lista completa, mira la sección 10.2 Tabla de Atajos.
