B.1 Utilisation des raccourcis

# Utilisation des raccourcis

Sonic Pi est tout autant un instrument qu'un environnement de programmation. Les raccourcis peuvent cependant rendre votre jeu avec Sonic Pi plus *efficace et naturel* - particulièrement quand vous jouez en direct devant un auditoire.

La plus grande part de Sonic Pi peut être contrôlée au moyen du clavier. Au fur et à mesure que vous deviendrez plus familier dans la pratique et l'interprétation avec Sonic Pi, vous commencerez probablement à utiliser de plus en plus de raccourcis. *Personnellement, je tape sans regarder le clavier* (je recommande que vous appreniez à le faire aussi) et je me sens frustré quand j'ai besoin d'attraper la souris parce que ça me retarde. J'utilise donc tous ces raccourcis très régulièrement !

Par conséquent, si vous apprenez les raccourcis, vous saurez utiliser efficacement votre clavier et vous coderez en direct comme un pro en peu de temps.

Toutefois, *n'essayez pas de les apprendre tous à la fois*, essayez et souvenez-vous simplement de ceux que vous utilisez le plus et continuez à en ajouter en supplément à votre pratique.

## Compatibilité entre plateformes

Imaginez que vous appreniez la clarinette. Vous vous attendriez à ce que toutes les clarinettes aient les mêmes contrôles et le même doigté. Si elles ne l'avaient pas, vous passeriez un moment pénible à basculer entre différentes clarinettes et vous seriez pris à rester toujours avec la même.

Unfortunately there are a number of standards for shortcuts with macOS and Windows being two of the major styles and other more esoteric editors such as Emacs offering other approaches. You can currently choose between one of these three styles using the menu `IO -> Shortcut Mode`. You can therefore switch between a Windows and a macOS machine and keep your shortcuts consistent.

## "Control" et "Meta"

A key part of the notion of consistency is the naming of shortcuts. In Sonic Pi we use the names *Control* and *Meta* to refer to the two main combination keys. On all platforms *Control* is the same. However, on Linux and Windows, *Meta* is actually the *Alt* key while on Mac *Meta* is the *Command* key. For consistency we'll use the term *Meta* - just remember to map that to the appropriate key on your operating system.

## Abréviations

Pour conserver les choses simples et lisibles, nous utiliserons les abréviations *C-* pour *Control* plus une autre touche et *M-* pour *Meta* plus une autre touche. Par exemple, si un raccourci consiste à maintenir enfoncées à la fois *meta* et *r*, nous l'écrirons *M-r*. Le *-* veut dire simplement "en même temps que."

Voici ci-dessous les raccourcis que j'estime les plus utiles.

## Arrêter et démarrer

Au lieu de toujours attraper la souris pour exécuter votre code, vous pouvez simplement presser `M-r`. Similairement, pour stopper l'exécution de votre code, vous pouvez presser `M-s`.

## Navigation

Je suis vraiment perdu sans les raccourcis de navigation. Je recommande donc vivement que vous passiez du temps à les apprendre. Ces raccourcis fonctionnent aussi extrêmement bien quand vous apprenez à taper sans regarder le clavier parce qu'ils utilisent des lettres standards sans nécessiter de déplacer votre main jusqu'à la souris ou jusqu'aux touches flèches de votre clavier.

For example, if you're in Emacs Live short cut mode, You can move to the beginning of the line with `C-a`, the end of the line with `C-e`, up a line with `C-p`, down a line with `C-n`, forward a character with `C-f`, and back a character with `C-b`. You can even delete all the characters from the cursor to the end of the line with `C-k`. Other modes will have their own shortcuts which can be easily discovered in the app menu.

## Code ordonné

Pour aligner et indenter automatiquement vos lignes de code, pressez `M-m`.

## Système d'aide

Pour afficher/cacher le système d'aide vous pouvez presser `M-i`. Toutefois, un raccourci plus utile à connaître est `C-i`. Il détecte le mot où se trouve le curseur et affiche la documentation le concernant s'il la trouve. Aide instantanée !

Pour une liste complète, jetez un œil à la section B.2 - Antisèche des raccourcis.
