10.1 Utilizzare le scorciatoie

# Utilizzare le scorciatoie

Sonic Pi è uno strumento così come è un ambiente di sviluppo. Le scorciatoie possono rendere l'esperienza di Sonic Pi più *efficace e naturale*, soprattutto se suoni live di fronte a un pubblico.

Sonic Pi può essere controllato in larga parte grazie alla tastiera. Familiarizzando con Sonic Pi, comincerai a utilizzare sempre di più le scorciatoie. Io *suono con la tastiera* (e vi consiglio di imparare a farlo) e mi ritrovo ad essere frustrato ogni volta che devo usare il mouse perché mi rallenta. Per questo uso queste scorciatoie regolarmente!

Se impari a utilizzare le scorciatoie, programmerai live come un professionista in men che non si dica.

Mi raccomando: *non provare a impararli tutti in una volta*, cerca di ricordare quelli che usi più spesso e di aggiungerne qualcuno a mano a mano che ti eserciti.

## Coerenza tra le piattaforme

Immagina se stessi imparando a suonare il clarinetto. Ti aspetteresti che ogni clarinetto abbia gli stessi controlli e la stessa ditteggiatura. Se così non fosse, faresti fatica a suonare clarinetti diversi e saresti costretto a usarne soltanto uno.

Unfortunately there are a number of standards for shortcuts with macOS and Windows being two of the major styles and other more esoteric editors such as Emacs offering other approaches. You can currently choose between one of these three styles using the menu `IO -> Shortcut Mode`. You can therefore switch between a Windows and a macOS machine and keep your shortcuts consistent.

## Controllo e Meta

A key part of the notion of consistency is the naming of shortcuts. In Sonic Pi we use the names *Control* and *Meta* to refer to the two main combination keys. On all platforms *Control* is the same. However, on Linux and Windows, *Meta* is actually the *Alt* key while on Mac *Meta* is the *Command* key. For consistency we'll use the term *Meta* - just remember to map that to the appropriate key on your operating system.

## Abbreviazioni

Per semplicità utilizzeremo delle abbreviazioni *C-* per *Controllo* e *M-* per *Meta*. Per esempio se per una scorciatoia devi tenere premuti contemporaneamente *Meta* e *r* noi scriveremo *M-r*. Il *-* indica "premi insieme."

Questi sono alcune delle scorciatoie più utili.

## Fermarsi e ripartire

Invece che andare alla ricerca del mouse per far funzionare il tuo codice, puoi premere `M-r`. Allo stesso modo, per fermare premi `M-s`.

## Navigazione

Io mi sento davvero perso senza le scorciatoie di navigazione. Per questo ti consiglio di investire parte del tuo tempo per impararle. Queste scorciatoie funzionano molto bene quando vuoi muoverti solo utilizzando la tastiera invece che muovendo il mouse o le frecce sulla tastiera.

For example, if you're in Emacs Live short cut mode, You can move to the beginning of the line with `C-a`, the end of the line with `C-e`, up a line with `C-p`, down a line with `C-n`, forward a character with `C-f`, and back a character with `C-b`. You can even delete all the characters from the cursor to the end of the line with `C-k`. Other modes will have their own shortcuts which can be easily discovered in the app menu.

## Codice più pulito

Per allineare automaticamente il codice, premi semplicemente 'M-m'.

## Sistema di aiuto

Per aprire il pannello di aiuto, puoi premere `M-i`. Tuttavia è importante conoscere anche la scorciatoia `C-i` che ti aiuta a trovare nella documentazione la parola che si trova sotto il cursore per un aiuto immediato!

Per una lista completa, dai un'occhiata alla sezione 10.2 con il riassunto di tutte le scorciatoie.
