1.2 인터페이스 둘러보기

# 소닉 파이(Sonic Pi) 인터페이스

소닉 파이는 음악을 코딩하기 위한 매우 간단한 인터페이스를 가지고 있습니다. 잠시 시간을 내어서 살펴보죠.

![Sonic Pi Interface](../../../etc/doc/images/tutorial/GUI.png)


* *A* - 재생 제어 버튼
* *B* - 에디터 설정 버튼
* *C* - 프로그램 정보와 도움말
* *D* - 코드 에디터
* *E* - 환경설정 패널
* *F* - 로그 뷰어
* *G* - 도움말 시스템
* *H* - 스코프 뷰어
* *I* - 큐 뷰어

## A. 재생 제어 버튼

이 핑크색 버튼들은 사운드를 시작하고 중지하는데 쓰는 주요한 제어장치입니다. 에디터에서 코드를 실행할 때 사용하는 *Run* 버튼, 실행 중인 코드를 중지시킬 때 쓰는 *Stop* 버튼, 코드를 파일로 저장할 때 쓰는 *Save* 버튼, 연주되는 사운드를 녹음할 때(WAV 파일로) 사용하는 *Record* 버튼이 있습니다.

## B. 에디터 설정 버튼

이 주황색 버튼들로 코드 편집기를 설정할 수 있습니다. *Size +* 및 *Size -* 버튼을 사용하면 텍스트를 더 크게 또는 더 작게 만들 수 있습니다.

## C. 프로그램 정보와 도움말

이곳의 파랑색 버튼들은 정보, 도움말, 환경 설정에 접근할 때 사용합니다. *Info* 버튼은 핵심 개발진, 역사, 기여자, 커뮤니티 같은 소닉 파이 자체에 관한 정보를 담고 있는 윈도우를 열어줍니다. *Help* 버튼은 도움말 시스템(*G*)을 열거나 끄고, *Prefs* 버튼은 기본적인 시스템 변수을 조정할 수 있는 환경설정 윈도우를 열거나 끕니다.

## D. 코드 에디터

이 영역은 여러분이 코드를 쓰거나 음악을 작곡/연주하는 곳입니다. 코드를 쓰거나, 삭제하거나, 자르거나, 붙이는 작업을 할 수 있는 심플한 텍스트 에디터 입니다. 마이크로소프트의 워드(Word)나 구글 독스(Google Docs)의 아주 기본 버전이라고 생각하시면 됩니다. 이 에디터는 코드 내에서 갖는 의미에 따라 자동적으로 단어에 색을 입힙니다. 처음는 이상하게 보일 수도 있게지만, 곧 매우 유용하다는 것을 알게 될 것입니다. 예를 들면, 어떤 단어가 파랑색이라면 그것이 숫자라는 것을 알게 될 것입니다.

## E. 환경설정 패널

소닉 파이는 여러 가지 조정 가능한 환경 설정을 지원하며, 이는 정보 및 도움말 버튼 모음 내 *prefs* 버튼을 전환하여 접근할 수 있습니다. 이를 통해 환경 설정 패널을 소환하여 여러 옵션을 변경할 수 있습니다. 예를 들어, 모노 모드, 스테레오 좌우 반전, 로그 출력 상세도 설정, 라즈베리 파이에서 볼륨 슬라이더 및 오디오 설정 등이 있습니다.

## F. 로그 뷰어

코드를 실행하면, 프로그램이 수행하는 작업에 대한 정보가 로그 뷰어에 표시됩니다. 기본적으로 여러분이 생성한 모든 사운드에 대한 메시지를 사운드가 실행된 정확한 시간과 함께 볼 수 있습니다. 이 기능은 코드를 디버깅하고 코드가 하는 일을 이해하는데 매우 유용합니다.

## G. 도움말 시스템

소닉 파이 인터페이스의 가장 중요한 부분 중의 하나는 화면 하단부에 보이는 도움말 시스템입니다. 이 기능은 파랑색 *Help* 버튼을 눌러서 켜거나 끌 수 있습니다. 도움말 시스템은 이 튜토리얼, 사용가능한 신스, 샘플, 예제, FX 및 소닉 파이가 음악 코딩을 위해 제공하는 전체 함수목록을 포함하여 소닉 파이의 모든 측면에 대한 도움말과 정보를 포함하고 있습니다.

## H. 스코프 뷰어

스코프 뷰어는 들리는 소리를 볼 수 있도록 만들어 줍니다. 톱니파가 톱니처럼 보이고, 기본 삐소리가 곡선 사인파인 것을 쉽게 알 수 있습니다. 선의 크기로 큰 소리와 작은 소리의 차이를 확인할 수도 있습니다. 3가지 종류의 스코프가 있습니다 - 기본값은 왼쪽 채널과 오른쪽 채널이 조합된 스코프이며, 각 채널에 대해 각각 별도의 스코프를 표시하는 스테레오 스코프도 있습니다. 마지막으로 왼쪽 채널과 오른쪽 채널사이의 위상 관계를 보여주는 리사주 곡선 스코프가 있으며, 이것은 소리로 예쁜 그림을 그릴 수 있습니다 (https://en.wikipedia.org/wiki/Lissajous_curve).

## I. 큐 뷰어

모든 내부 및 외부 이벤트(이벤트는 소닉 파이에서 큐라고 합니다)는 자동으로 큐 뷰어에 기록됩니다. 예를 들어, MIDI 컨트롤러를 연결하고 버튼을 누르면, 큐 뷰어에 컨트롤러 이름과 누른 버튼을 알려주는 새로운 큐 이벤트가 표시됩니다. 소리 만들기와 제작의 기본을 익히고 나면, 이러한 이벤트를 기반으로 소리나 소리의 전체 섹션을 큐잉하고 싶어질 것입니다. 큐 이벤트는 단지 무언가가 발생했다는 표시일 뿐입니다. 예를 들어, 라이브 루프가 한 바퀴 돌 때마다 큐 이벤트를 보내고, 이는 큐 뷰어에 기록됩니다. 또한, 연결된 MIDI 장비에서 오는 MIDI 메시지와 다른 프로그램이나 컴퓨터에서 오는 OSC 메시지와 같은 외부 이벤트도 큐 뷰어에 표시됩니다. `cue` 함수를 사용하여 직접 큐 이벤트를 생성하는 것도 가능합니다. 큐 뷰어에 나타나는 모든 것은 무언가가 발생하도록 트리거할 수 있습니다. 이에 대한 자세한 내용은 이 튜토리얼의 10~12장에서 다룹니다.
