B.1 Korzystanie ze Skrótów Klawiszowych

# Korzystanie ze Skrótów Klawiszowych

Sonic Pi jest zarówno instrumentem muzycznym, jak i środowiskiem programistycznym. Skróty klawiszowe mogą więc sprawić, że granie z Sonic Pi będzie dużo bardziej *wydajne i naturalne* - zwłaszcza wtedy, gdy będziesz występować na żywo przed publicznością.

Wiele funkcji Sonic Pi może być kontrolowanych za pomocą klawiatury. Gdy posiądziesz już więcej wprawy w pracy i występach z Sonic Pi, na pewno zaczniesz używać skrótów coraz częściej i częściej. *Potrafię pisać na klawiaturze bezwzrokowo* (Tobie też polecam się tego nauczyć) i czuję frustrację za każdym razem, kiedy tylko muszę sięgnąć po myszkę, ponieważ to spowalnia moją pracę. W związku z powyższym używam wszystkich tych skrótów w kółko!

Ponadto, jeśli nauczysz się skrótów, zyskasz umiejętność korzystania z Twojej klawiatury dużo bardziej efektywnie i zaczniesz kodować na żywo niczym profesjonalista w bardzo krótkim czasie.

Jednakże *nie próbuj i nie ucz się ich wszystkich na raz* - postaraj się sprawdzić i zapamiętać tylko te, których używasz najczęściej. Dopiero potem postaraj się regularnie dodawać i ćwiczyć kolejne.

## Spójność pomiędzy Platformami

Wyobraź sobie, że uczysz się gry na klarnecie. Zapewne oczekiwałbyś, że wszystkie z nich będą zapewniały podobną kontrole i palcowanie. Jeśli nie, to potrzebowałbyś sporo czasu za każdym razem, gdy przesiadałbyś się pomiędzy różnymi klarnetami i tak naprawdę byłbyś wtedy ograniczony do korzystania tylko z jednego wybranego modelu.

Unfortunately there are a number of standards for shortcuts with macOS and Windows being two of the major styles and other more esoteric editors such as Emacs offering other approaches. You can currently choose between one of these three styles using the menu `IO -> Shortcut Mode`. You can therefore switch between a Windows and a macOS machine and keep your shortcuts consistent.

## Klawisze Control i Meta

A key part of the notion of consistency is the naming of shortcuts. In Sonic Pi we use the names *Control* and *Meta* to refer to the two main combination keys. On all platforms *Control* is the same. However, on Linux and Windows, *Meta* is actually the *Alt* key while on Mac *Meta* is the *Command* key. For consistency we'll use the term *Meta* - just remember to map that to the appropriate key on your operating system.

## Skróty

Aby dalsze instrukcje były proste i czytelne, będziemy używać skrótu *C-* dla klawisza *Control* plus innego klawisza oraz *M-* dla *Meta* plus inny klawisz. Na przykład, jeśli skrót klawiszowy wymaga, abyś nacisnął razem klawisze *Meta* i *r*, zapiszemy to jako `M-r`. Symbol *-* oznacza po prostu "w tym samym czasie co."

Przedstawię Ci kilka skrótów klawiszowych, które są dla mnie najbardziej przydatne.

## Zatrzymywanie i uruchamianie

Zamiast za każdym razem sięgać po myszkę, aby uruchomić Twój kod, możesz po prostu nacisnąć skrót `M-r`. Podobnie, aby zatrzymać uruchomiony kod, możesz nacisnąć `M-s`.

## Nawigacja

Bez skrótów umożliwiających nawigację czuję się naprawdę zagubiony. W związku z tym bardzo zalecam Ci spędzić tyle czasu, ile potrzeba, aby się ich nauczyć. Działają one również bardzo dobrze, kiedy już nauczysz się pisać na klawiaturze bezwzrokowo, jako że używają standardowych liter i nie wymagają od Ciebie, abyś sięgał ręką do myszki lub klawiszy ze strzałkami na Twojej klawiaturze.

For example, if you're in Emacs Live short cut mode, You can move to the beginning of the line with `C-a`, the end of the line with `C-e`, up a line with `C-p`, down a line with `C-n`, forward a character with `C-f`, and back a character with `C-b`. You can even delete all the characters from the cursor to the end of the line with `C-k`. Other modes will have their own shortcuts which can be easily discovered in the app menu.

## Elegancki Kod

Aby automatycznie wyrównać Twój kod, wystarczy, że naciśniesz `M-m`.

## System Pomocy

Aby pokazać i ukryć system pomocy, możesz nacisnąć przycisk `M-i`. Jednakże dużo bardziej przydatnym skrótem, który warto znać, jest `C-i` - pozwala on na wyszukanie w systemie pomocy słowa, na którym aktualnie znajduje się kursor i wyświetlenie tego, jeśli uda mu się znaleźć cokolwiek. Pomoc błyskawiczna!

Aby zobaczyć pełną listę dostępnych skrótów klawiszowych, zajrzyj do rozdziału 10.2 Ściągawka Skrótów Klawiszowych.
