10.1 Usando atalhos

# Usando atalhos

O Sonic Pi é tanto um instrumento como um ambiente de codificação. Atalhos podem fazer com que tocar o Sonic Pi seja muito mais *eficiente e natural* - especialmente se estiveres a tocar em frente a uma audiência.

Muito do Sonic Pi pode ser controlado através do teclado. Quanto mais familiaridade tiveres trabalhando e actuando com o Sonic Pi mais tendência terás de usar atalhos. *Eu pessoalmente uso o teclado* (eu recomendo considerares aprenderes também) sinto-me frustrado quando tenho que alcançar o rato pois isso atrasa-me. Por isso uso todos estes atalhos de uma forma bastante regular!

Assim, se aprenderes os atalhos, aprenderás a usar o teclado de forma efectiva e estarás a fazer live coding como um profissional em tempo record.

No entanto, *não tentes aprende-los todos de uma só vez*, apenas tenta lembrar-te dos que mais usas e continua a adicionar mais à medida que os praticas.

## Consistência entre plataformas

Imagina que estas a aprender o clarinete. Esperas que todos os clarinetes tenham os mesmos controles e botões. Se não tiverem, terás um tempo difícil a mudar entre vários clarinetes ou ficaras retido em usar só um.

Unfortunately there are a number of standards for shortcuts with macOS and Windows being two of the major styles and other more esoteric editors such as Emacs offering other approaches. You can currently choose between one of these three styles using the menu `IO -> Shortcut Mode`. You can therefore switch between a Windows and a macOS machine and keep your shortcuts consistent.

## Control e Meta

A key part of the notion of consistency is the naming of shortcuts. In Sonic Pi we use the names *Control* and *Meta* to refer to the two main combination keys. On all platforms *Control* is the same. However, on Linux and Windows, *Meta* is actually the *Alt* key while on Mac *Meta* is the *Command* key. For consistency we'll use the term *Meta* - just remember to map that to the appropriate key on your operating system.

## Abreviações

Para ajudar a manter as coisas simples e legíveis, usaremos as abreviaturas *C-* para *Control* mais uma outra tecla e *M-* para *Meta* mais outra tecla. Por exemplo, se um atalho requer que primas simultaneamente *Meta* e *r* escreveremos como *M-r*. O *-* significa apenas "ao mesmo tempo".

Os seguintes são alguns dos atalhos que considero mais úteis.

## Parando e iniciando

Em vez de alcançar o rato cada vez que se quer correr o código, podes simplesmente pressionar `M-r`. Da mesma forma podes parar o código carregando `M-s`.

## Navegação

Fico mesmo perdido sem os atalhos de navegação. Recomendo vivamente que passes algum tempo a aprende-los. Estes atalhos trabalhas extremamente bem quando aprendes a teclar sem mexer as mãos pois eles usam letras standard e não requerem que mexas as mãos para alcançar o rato ou as setas do teu teclado.

For example, if you're in Emacs Live short cut mode, You can move to the beginning of the line with `C-a`, the end of the line with `C-e`, up a line with `C-p`, down a line with `C-n`, forward a character with `C-f`, and back a character with `C-b`. You can even delete all the characters from the cursor to the end of the line with `C-k`. Other modes will have their own shortcuts which can be easily discovered in the app menu.

## Código limpo

Para auto-alinhar o teu código simplesmente carrega `M-m`.

## Sistema de ajuda

Para comutar o sistema de ajuda podes premir `M-i`- No entanto, um atalho muito mais útil é `C-i` em que irá verificar a palavra por baixo do cursor e mostra os documentos se descobrir algo. Ajuda instantânea!

Para uma listagem completa vê a secção 10.2 com uma folha de ajuda de atalhos.
